-- phpMyAdmin SQL Dump
-- version 5.1.0
-- https://www.phpmyadmin.net/
--
-- Počítač: 127.0.0.1
-- Vytvořeno: Úte 26. dub 2022, 15:37
-- Verze serveru: 10.4.19-MariaDB
-- Verze PHP: 8.0.6

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Databáze: `bittip`
--

-- --------------------------------------------------------

--
-- Struktura tabulky `contents`
--

CREATE TABLE `contents` (
  `id` int(11) NOT NULL,
  `public_id` varchar(100) NOT NULL COMMENT 'id definované třetí stranou (veřejné)',
  `private_id` varchar(100) NOT NULL COMMENT 'id contentu definované třetí stranou (privátní)',
  `master_id` varchar(100) NOT NULL COMMENT 'id nadřazené entity - tvůrce',
  `profile_id` int(11) NOT NULL,
  `url` varchar(200) DEFAULT NULL,
  `platform` varchar(20) NOT NULL,
  `title` varchar(200) DEFAULT NULL,
  `description` text DEFAULT NULL,
  `publish_date` datetime DEFAULT NULL,
  `create_date` datetime NOT NULL DEFAULT current_timestamp(),
  `update_date` datetime NOT NULL DEFAULT current_timestamp(),
  `active` tinyint(1) NOT NULL DEFAULT 1
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `contents`
--
DELIMITER $$
CREATE TRIGGER `contents_insert_before` BEFORE INSERT ON `contents` FOR EACH ROW SET new.create_date = NOW(), new.update_date = NOW()
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `contents_update_before` BEFORE UPDATE ON `contents` FOR EACH ROW SET new.update_date = NOW()
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabulky `extension_params`
--

CREATE TABLE `extension_params` (
  `id` int(11) NOT NULL,
  `name` varchar(30) NOT NULL,
  `value` text NOT NULL,
  `value_type` varchar(20) NOT NULL DEFAULT 'TEXT' COMMENT 'typ hodnoty (datum, text, number,...)',
  `entity_type` varchar(20) NOT NULL COMMENT 'určuje typ entity, ke které je hodnota vázaná (USER, CONTENT, PROFILE, ...)',
  `entity_id` int(11) NOT NULL COMMENT 'id entity, ke které je hodnota navázaná'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Struktura tabulky `payments`
--

CREATE TABLE `payments` (
  `id` int(11) NOT NULL,
  `wallet_id` int(11) NOT NULL,
  `type` varchar(20) NOT NULL COMMENT 'tip, withdraw',
  `amount` int(11) NOT NULL DEFAULT 0 COMMENT 'pozor jde o MILISATOSHI',
  `fees` int(11) NOT NULL DEFAULT 0,
  `payed` tinyint(1) NOT NULL DEFAULT 0,
  `pay_date` datetime DEFAULT NULL,
  `pay_index` int(11) DEFAULT NULL,
  `r_hash` varchar(255) DEFAULT NULL,
  `pay_req` varchar(1000) DEFAULT NULL,
  `memo` text NOT NULL,
  `pay_hash` varchar(1000) DEFAULT NULL,
  `add_index` int(11) DEFAULT NULL,
  `pay_address` varchar(255) DEFAULT NULL,
  `lnurl_secret` varchar(100) DEFAULT NULL,
  `create_date` datetime NOT NULL DEFAULT current_timestamp(),
  `update_date` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `payments`
--
DELIMITER $$
CREATE TRIGGER `payments_insert_before` BEFORE INSERT ON `payments` FOR EACH ROW SET new.create_date = NOW(), new.update_date = NOW()
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `payments_update_before` BEFORE UPDATE ON `payments` FOR EACH ROW SET new.update_date = NOW()
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabulky `profiles`
--

CREATE TABLE `profiles` (
  `id` int(11) NOT NULL,
  `platform_user_id` varchar(150) NOT NULL COMMENT 'id uživatele definované v aplikaci třetích stran',
  `content_master_id` varchar(150) NOT NULL COMMENT 'id profilu, které definuje vztah mezi profilem a contentem (může být stejné jako app_user_id)',
  `user_id` int(11) NOT NULL COMMENT 'id lokálního uživatele (tabulka users)',
  `user_name` varchar(100) DEFAULT NULL,
  `display_name` varchar(60) NOT NULL,
  `full_name` varchar(80) DEFAULT NULL,
  `email` varchar(60) DEFAULT NULL,
  `email_verified` tinyint(1) DEFAULT NULL,
  `platform` varchar(20) NOT NULL COMMENT 'kód platformy (YOUTUBE, MEDIUM)',
  `content_sync_date` datetime DEFAULT NULL,
  `access_token` varchar(300) DEFAULT NULL,
  `expire_date` datetime DEFAULT NULL,
  `refresh_token` varchar(300) DEFAULT NULL,
  `url` varchar(200) DEFAULT NULL COMMENT 'url odkazující na stránku profilu',
  `img_url` varchar(300) DEFAULT NULL,
  `create_date` datetime NOT NULL DEFAULT current_timestamp(),
  `update_date` datetime NOT NULL DEFAULT current_timestamp(),
  `active` tinyint(1) NOT NULL DEFAULT 1
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `profiles`
--
DELIMITER $$
CREATE TRIGGER `profiles_insert_before` BEFORE INSERT ON `profiles` FOR EACH ROW SET new.create_date = NOW(), new.update_date = NOW()
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `profiles_update_before` BEFORE UPDATE ON `profiles` FOR EACH ROW SET new.update_date = NOW()
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabulky `tips`
--

CREATE TABLE `tips` (
  `id` int(11) NOT NULL,
  `recipient_user_id` int(11) NOT NULL COMMENT 'id příjemce tipu',
  `recipient_profile_id` int(11) NOT NULL,
  `sender_user_id` int(11) DEFAULT NULL COMMENT 'id odesílatele (pokud je přihlášen)',
  `content_id` int(11) DEFAULT NULL,
  `payment_id` int(11) NOT NULL,
  `message` varchar(300) DEFAULT NULL COMMENT 'zpráva pro příjemce',
  `platform` varchar(20) NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT 1,
  `create_date` datetime NOT NULL,
  `update_date` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `tips`
--
DELIMITER $$
CREATE TRIGGER `tips_insert_before` BEFORE INSERT ON `tips` FOR EACH ROW SET new.create_date = NOW(), new.update_date = NOW()
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `tips_update_before` BEFORE UPDATE ON `tips` FOR EACH ROW SET new.update_date = NOW()
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabulky `urls`
--

CREATE TABLE `urls` (
  `hash` varchar(255) DEFAULT NULL,
  `apiKeyId` varchar(255) DEFAULT NULL,
  `tag` varchar(255) DEFAULT NULL,
  `params` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_bin DEFAULT NULL CHECK (json_valid(`params`)),
  `initialUses` int(10) UNSIGNED DEFAULT 1,
  `remainingUses` int(10) UNSIGNED DEFAULT 0,
  `createdAt` timestamp NOT NULL DEFAULT current_timestamp(),
  `updatedAt` timestamp NOT NULL DEFAULT current_timestamp()
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Struktura tabulky `users`
--

CREATE TABLE `users` (
  `id` int(11) NOT NULL,
  `display_name` varchar(60) NOT NULL,
  `full_name` varchar(80) DEFAULT NULL,
  `email` varchar(60) DEFAULT NULL,
  `email_verified` tinyint(1) NOT NULL DEFAULT 0,
  `password` varchar(200) DEFAULT NULL,
  `is_loginable` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'určuje zda má uživatel nastavený heslo a verifikovaný email e může se přihlásit bez propojení do jiné aplikace',
  `wallet_id` int(11) DEFAULT NULL,
  `role` varchar(10) NOT NULL DEFAULT 'USER',
  `img_url` varchar(300) DEFAULT NULL,
  `create_date` datetime NOT NULL DEFAULT current_timestamp(),
  `update_date` datetime NOT NULL DEFAULT current_timestamp(),
  `active` tinyint(1) NOT NULL DEFAULT 1
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `users`
--
DELIMITER $$
CREATE TRIGGER `users_insert_before` BEFORE INSERT ON `users` FOR EACH ROW SET new.create_date = NOW(), new.update_date = NOW()
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `users_update_before` BEFORE UPDATE ON `users` FOR EACH ROW SET new.update_date = NOW()
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabulky `wallets`
--

CREATE TABLE `wallets` (
  `id` int(11) NOT NULL,
  `amount` int(11) NOT NULL DEFAULT 0 COMMENT 'pozor jde o MILISATOSHI',
  `withdraw_amount` int(11) NOT NULL DEFAULT 0,
  `tips_count` int(11) NOT NULL DEFAULT 0,
  `create_date` datetime NOT NULL,
  `update_date` datetime NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT 1
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `wallets`
--
DELIMITER $$
CREATE TRIGGER `wallets_insert_before` BEFORE INSERT ON `wallets` FOR EACH ROW SET new.create_date = NOW(), new.update_date = NOW()
$$
DELIMITER ;
DELIMITER $$
CREATE TRIGGER `wallets_update_before` BEFORE UPDATE ON `wallets` FOR EACH ROW SET new.update_date = NOW()
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabulky `wallets_history`
--

CREATE TABLE `wallets_history` (
  `id` int(11) NOT NULL,
  `wallet_id` int(11) NOT NULL,
  `amount` int(11) NOT NULL,
  `tips_count` int(11) NOT NULL,
  `create_date` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Triggery `wallets_history`
--
DELIMITER $$
CREATE TRIGGER `wallets_history_insert_before` BEFORE INSERT ON `wallets_history` FOR EACH ROW SET new.create_date = NOW()
$$
DELIMITER ;

--
-- Indexy pro exportované tabulky
--

--
-- Indexy pro tabulku `contents`
--
ALTER TABLE `contents`
  ADD PRIMARY KEY (`id`),
  ADD KEY `FK_profile_id` (`profile_id`);

--
-- Indexy pro tabulku `extension_params`
--
ALTER TABLE `extension_params`
  ADD PRIMARY KEY (`id`);

--
-- Indexy pro tabulku `payments`
--
ALTER TABLE `payments`
  ADD PRIMARY KEY (`id`);

--
-- Indexy pro tabulku `profiles`
--
ALTER TABLE `profiles`
  ADD PRIMARY KEY (`id`),
  ADD KEY `FK_user_id` (`user_id`);

--
-- Indexy pro tabulku `tips`
--
ALTER TABLE `tips`
  ADD PRIMARY KEY (`id`),
  ADD KEY `FK_content_id` (`content_id`),
  ADD KEY `FK_payment_id` (`payment_id`);

--
-- Indexy pro tabulku `urls`
--
ALTER TABLE `urls`
  ADD UNIQUE KEY `urls_hash_unique` (`hash`);

--
-- Indexy pro tabulku `users`
--
ALTER TABLE `users`
  ADD PRIMARY KEY (`id`),
  ADD KEY `FK_wallet_id` (`wallet_id`);

--
-- Indexy pro tabulku `wallets`
--
ALTER TABLE `wallets`
  ADD PRIMARY KEY (`id`);

--
-- Indexy pro tabulku `wallets_history`
--
ALTER TABLE `wallets_history`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT pro tabulky
--

--
-- AUTO_INCREMENT pro tabulku `contents`
--
ALTER TABLE `contents`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `extension_params`
--
ALTER TABLE `extension_params`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `payments`
--
ALTER TABLE `payments`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `profiles`
--
ALTER TABLE `profiles`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `tips`
--
ALTER TABLE `tips`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `users`
--
ALTER TABLE `users`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `wallets`
--
ALTER TABLE `wallets`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT pro tabulku `wallets_history`
--
ALTER TABLE `wallets_history`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- Omezení pro exportované tabulky
--

--
-- Omezení pro tabulku `contents`
--
ALTER TABLE `contents`
  ADD CONSTRAINT `FK_profile_id` FOREIGN KEY (`profile_id`) REFERENCES `profiles` (`id`);

--
-- Omezení pro tabulku `profiles`
--
ALTER TABLE `profiles`
  ADD CONSTRAINT `FK_user_id` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`);

--
-- Omezení pro tabulku `tips`
--
ALTER TABLE `tips`
  ADD CONSTRAINT `FK_content_id` FOREIGN KEY (`content_id`) REFERENCES `contents` (`id`),
  ADD CONSTRAINT `FK_payment_id` FOREIGN KEY (`payment_id`) REFERENCES `payments` (`id`);

--
-- Omezení pro tabulku `users`
--
ALTER TABLE `users`
  ADD CONSTRAINT `FK_wallet_id` FOREIGN KEY (`wallet_id`) REFERENCES `wallets` (`id`);
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
